<?php

namespace FiloBlu\Refilo\Model\Indexer\Core;

use FiloBlu\Refilo\Model\Adapter\Mongo;
use FiloBlu\Refilo\Model\Indexer\Core\Provider\QueryProviderInterfaceFactory;
use Magento\Framework\App\Config\ScopeConfigInterface;

class BaseMongoIndexer extends AbstractMongoIndexer
{
    /**
     * @var string
     */
    private $mongoKey;
    /**
     * @var string
     */
    private $mongoCollection;
    /**
     * @var bool
     */
    private $insertMode;
    /**
     * @var string
     */
    private $databaseConfigurationKey;

    /**
     * BaseMongoIndexer constructor.
     * @param SqlToMongoAdapterInterface $sqlToMongoAdapter
     * @param QueryProviderInterfaceFactory $queryProviderFactory
     * @param ScopeConfigInterface $scopeConfig
     * @param Mongo $mongo
     * @param string $mongoKey
     * @param string $mongoCollection
     * @param bool $insertMode
     * @param string $databaseConfigurationKey
     */
    public function __construct(
        SqlToMongoAdapterInterface $sqlToMongoAdapter,
        QueryProviderInterfaceFactory $queryProviderFactory,
        ScopeConfigInterface $scopeConfig,
        Mongo $mongo,
        string $mongoKey,
        string $mongoCollection,
        bool $insertMode,
        string $databaseConfigurationKey
    ) {
        parent::__construct($sqlToMongoAdapter, $queryProviderFactory, $scopeConfig, $mongo, $databaseConfigurationKey);
        $this->mongoKey = $mongoKey;
        $this->mongoCollection = $mongoCollection;
        $this->insertMode = $insertMode;
        $this->databaseConfigurationKey = $databaseConfigurationKey;
    }

    public function getMongoKey(): string
    {
        return $this->mongoKey;
    }

    public function getTargetMongoCollection(): string
    {
        return $this->mongoCollection;
    }

    public function getInsertMode(): bool
    {
        return $this->insertMode;
    }

}
